# Jobs that are generally executable locally (as well as within CI)
#
.test-job:
  stage: test
  needs: []

docs-lint:
  extends:
    - .test-job
    - .rules:docs-changes
  image: registry.gitlab.com/gitlab-org/gitlab-docs/lint-markdown:alpine-3.18-vale-2.27.0-markdownlint-0.35.0-markdownlint2-0.8.1
  script:
    - make lint

rubocop:
  extends:
    - .test-job
    - .rules:code-changes
  image: "ruby:${RUBY_VERSION}"
  script:
    - make rubocop
  parallel:
    matrix:
      - RUBY_VERSION: ['3.0', '3.1', '3.2']

rspec:
  extends:
    - .test-job
    - .rules:code-changes
  image: "ruby:${RUBY_VERSION}"
  variables:
    RSPEC_ARGS: "--format doc --format RspecJunitFormatter --out rspec.xml"
  script:
    - pwd > .gdk-install-root
    - make rspec
  cache:
    key: "ruby-${RUBY_VERSION}-bundle"
    paths:
      - $BUNDLE_PATH
  artifacts:
    paths:
      - rspec.xml
    reports:
      junit: rspec.xml
      coverage_report:
        coverage_format: cobertura
        path: coverage/coverage.xml
  parallel:
    matrix:
      - RUBY_VERSION: ['3.0', '3.1', '3.2']

shellcheck:
  extends:
    - .test-job
    - .rules:code-changes
  image: "ruby:${RUBY_VERSION}"
  script:
    - apt-get update
    - make shellcheck
  parallel:
    matrix:
      - RUBY_VERSION: ['3.0', '3.1', '3.2']

checkmake:
  extends:
    - .test-job
    - .rules:code-changes
  image: registry.gitlab.com/gitlab-org/gitlab-development-kit/asdf-bootstrapped-verify:main
  script:
    - make checkmake

gdk-example-yml:
  extends:
    - .test-job
    - .rules:code-changes
  image: "ruby:${RUBY_VERSION}"
  script:
    - make verify-gdk-example-yml
  parallel:
    matrix:
      - RUBY_VERSION: ['3.0', '3.1', '3.2']

asdf-combine:
  extends:
    - .test-job
    - .rules:code-changes
  image: "ruby:${RUBY_VERSION}"
  artifacts:
    when: on_failure
    paths:
      - .tool-versions
  script:
    - make verify-asdf-combine
  rules:
    - if: '$CI_PIPELINE_SOURCE == "schedule"'
    - if: '$CI_MERGE_REQUEST_IID'
      changes:
        - ".tool-versions*"
        - "support/asdf-combine"
        - "support/ci/verify-asdf-combine"
  parallel:
    matrix:
      - RUBY_VERSION: ['3.0', '3.1', '3.2']

makefile-config:
  extends:
    - .test-job
    - .rules:code-changes
  image: "ruby:${RUBY_VERSION}"
  script:
    - support/ci/verify-makefile-config
  parallel:
    matrix:
      - RUBY_VERSION: ['3.0', '3.1', '3.2']

ruby-version:
  extends:
    - .test-job
    - .rules:ruby-version-changes
  image: "ruby:${RUBY_VERSION}"
  script:
    - support/ruby-check-versions
  parallel:
    matrix:
      - RUBY_VERSION: ['3.0', '3.1', '3.2']
